import java.awt.*;
import java.awt.event.*;

    // Illustrate the use of MouseAdapter to select a particular event
    // without having to implement the whole MouseListener interface.
class ClickPlotter extends MouseAdapter {
    public ClickPlotter(Component comp){
        setComponent(comp);
    }

        // Plot double-click points.
    public void mouseClicked(MouseEvent e){
        if(e.getClickCount() == 2){
            final int x = e.getX(), y = e.getY();
            getGraphics().drawLine(x,y,x,y);
        }
    }

    protected Graphics getGraphics(){
        return getComponent().getGraphics();
    }

    protected Component getComponent(){
        return component;
    }

    protected void setComponent(Component c){
        component = c;
    }

    private Component component;
}
