import java.util.LinkedList;

        // An implementation of a LIFO stack of Cards.
class CardStack {
    // Add a card to the stack.
    public void add(Card c){
        // Add it to the end.
        getStack().add(c);
    }

    // Remove (and return) the last card from the stack.
    public Card next(){
        if(size() > 0){
            return (Card) getStack().removeLast();
        }
        else{
            return null;
        }
    }

    // Return (but don't remove) the last card from the stack.
    public Card peek(){
        if(size() > 0){
            return (Card) getStack().getLast();
        }
        else{
            return null;
        }
    }

    // How many items in the stack?
    public int size(){
        LinkedList stack = getStack();
        return stack.size();
    }

    // Return a reference to the collection.
    private LinkedList getStack(){
        return stack;
    }

    // The collection of objects.
    private LinkedList stack = new LinkedList();
}
