import java.net.*;
import java.io.*;
import java.util.Random;

        // Provide random integers to the client on request.
        // The text of any request is ignored but used
        // as a prompt for when to send each number.
class RandomService extends TCPEndpoint implements Runnable {
    public RandomService(Socket s) throws Exception {
        super(s);
    }

        // Supply random integers on request to the client.
    public void run(){
        // The random number generator for this client.
        Random random = new Random();
        try{
            String request = getLine();
            while(request != null){
                // We are not interested in the text of the request.
                sendLine(""+random.nextInt());
                request = getLine();
            }
        }
        catch(IOException e){
            System.err.println("IOException: "+e.getMessage());
        }
        finally{
            close();
            System.out.println("Thread terminating.");
        }
    }
}
