        // Obtain details on the resources whose URLs are
        // passed as command line arguments.
import java.net.*;
import java.util.Date;

class URLDetails {
    public static void main(String[] args) {
        for(int i = 0; i < args.length; i++){
            try{
                URL url = new URL(args[i]);
                URLConnection connection = url.openConnection();

                // Strictly speaking, most of these are only relevant
                // for the HTTP protocol.
                System.out.println("Filename: "+url.getFile());
                System.out.println("Content type: "+
                                   connection.getContentType());
                System.out.println("Content length: "+
                                   connection.getContentLength());
                System.out.println("Content date: "+
                                   new Date(connection.getDate()));
                System.out.println("Content expiration date: "+
                                   new Date(connection.getExpiration()));
                System.out.println("Content last modified: "+
                                   new Date(connection.getLastModified()));
                System.out.println();
            }
            catch(Exception e){
                System.err.println("Exception: "+e);
            }
        }
    }
}
