        // The super class of all events in a simulation.
        // Maintain the time of the event and provide an abstract
        // perform method for the scheduler to use.
abstract public class Event {
    public Event(long eventTime){
        setWhen(eventTime);
    }

        // Each type of event defines its own behaviour when triggered.
    abstract public void perform(Scheduler s);
        
    public long getWhen(){
        return when;
    }

    protected void setWhen(long w){
        when = w;
    }

    // When this event is due to happen.
    private long when;
}
