import javax.swing.Icon;
import java.awt.*;

        // A circular icon.
class CircleIcon implements Icon {
    public static final int defaultWidth = 10;
    public static final Color defaultColor = Color.blue;

    public CircleIcon(){
        this(defaultWidth,defaultColor);
    }

    public CircleIcon(int w){
        this(w,defaultColor);
    }

    public CircleIcon(Color c){
        this(defaultWidth,c);
    }

    public CircleIcon(int w,Color c){
        width = w;
        color = c;
    }

        // The Icon interface.
    public int getIconHeight(){
        return width;
    }

    public int getIconWidth(){
        return width;
    }

    public void paintIcon(Component c, Graphics g, int x, int y){
        g.setColor(color);
        g.fillArc(x,y,width,width,0,360);
    }

    public Color getColor(){
        return color;
    }

    private final int width;
    private final Color color;
}
