import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

    // Illustrate a JColorChooser by allowing one to change the
    // background of a central panel.
class SwingColorFrame1 extends JFrame {
    public SwingColorFrame1(){
        final int width = 400, height = 200;
        setSize(width,height);

        final Container contents = getContentPane();

        JLabel label = new JLabel("Change the Background.",JLabel.CENTER);
        contents.add(label,"North");
        // Add a panel, whose background color will be changed.
        contents.add(getPanel(),"Center");

        // Set up Change + Quit buttons.
        final JPanel buttonPanel = new JPanel();
        setupButtons(buttonPanel);
        contents.add(buttonPanel,"South");
    }

        // Allow a JColorChooser to change the background color of
        // the central panel.
    protected void setupButtons(JPanel buttonPanel){
        final JButton quit = new QuitJButton("Quit"),
                      change = new JButton("Change");

        // The action to take when the Change button is pressed.
        // Show a color chooser and use the selected color.
        change.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                final JPanel p = getPanel();
                Color c = JColorChooser.showDialog(
                                SwingColorFrame1.this,
                                "Choose a Color",p.getBackground());
                if(c != null){
                    p.setBackground(c);
                }
            }
        });
        buttonPanel.add(change);
        buttonPanel.add(quit);
    }

    protected JPanel getPanel(){
        return panel;
    }

    // The panel whose background color is to be changed.
    private final JPanel panel = new JPanel();
}
