    // Objects of this class may be run in a separate thread.
    // Implementation provided for Runnable.run().
class FairCounter implements Runnable {
    public FairCounter(int min,int max){
        this.min = min;
        this.max = max;
    }

    // Print the numbers [min..max]
    public void run(){
        final int max = getMax();
        for(int i = getMin(); i <= max; i++){
            System.out.print(i+" ");
            try{
                // Let someone else have a go.
                Thread.sleep(100);
            }
            catch(InterruptedException e){
                // Someone woke us up.
            }
        }
        System.out.println();
    }

    public int getMin(){
        return min;
    }

    public int getMax(){
        return max;
    }

    // Range of numbers to be printed.
    private final int min, max;
}
